﻿using UnityEngine;
using UnityEngine.SceneManagement;

public class Restart : MonoBehaviour
{
    public static void LevelReset()
    {
        StageStatic.stage.ResetPlay();
        Loader.LoadStage(StageStatic.stage.name, !StageStatic.stage.use_install_folder, false);
    }

    public static void LoadMainMenu()
    {
        //not over SceneManager.LoadingScreen as MainMenu is too light to need to load over a LoadingScreen
        SceneManager.LoadScene("MainMenu");
    }


    public static void StageFactState_modundo()
    {
        StageStatic.stage.factState.undo();
    }
    public static void StageFactState_modredo()
    {
        StageStatic.stage.factState.redo();
    }

    public static void StageFactState_modreset()
    {
        StageStatic.stage.factState.softreset();
    }

    public static void Stage_modsave()
    {
        StageStatic.stage.push_record();
    }

    public static void StageFactState_modload()
    {
        StageStatic.stage.factState.hardreset();
        StageStatic.LoadInitStage(StageStatic.stage.name, !StageStatic.stage.use_install_folder);
    }


    public static void LoadStartScreen()
    {
        StartServer.process?.Kill();
        SceneManager.LoadScene(0);
    }

    public static void OnApplicationQuit()
    {
        StartServer.process?.Kill();
    }
}
